"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const index_1 = require("../index");
const input_1 = __importDefault(require("./input"));
const V = __importStar(require("@nexys/validation"));
const U = __importStar(require("../../headless/form/utils"));
const FormGenerator = ({ formDef, onSuccess, isLoading = false, valueDefault = {}, errors: errorsDefault, submit = { label: "Submit" }, }) => {
    const [data, setData] = react_1.default.useState(valueDefault);
    const [errors, setErrors] = react_1.default.useState(errorsDefault);
    react_1.default.useEffect(() => {
        setErrors(errorsDefault);
    }, [errorsDefault]);
    const validator = U.generateValidatorFromDef(formDef);
    const handleSubmit = (event) => {
        event.preventDefault();
        const v = V.Main.checkObject(data, validator);
        setErrors(v);
        // no errors found
        if (Object.values(v).length === 0) {
            //
            //alert(JSON.stringify(v));
            onSuccess(data);
        }
    };
    return (react_1.default.createElement("form", { onSubmit: handleSubmit },
        formDef.map((fd, i) => {
            const name = fd.name;
            const errorUnit = errors && errors[name];
            return (react_1.default.createElement(index_1.Wrapper, { errors: errorUnit, key: i, label: fd.label },
                react_1.default.createElement(input_1.default, { type: fd.uiType, errors: errorUnit, value: data[fd.name], onChange: (v) => setData({ ...data, [fd.name]: v }), options: fd.options, disabled: isLoading })));
        }),
        react_1.default.createElement("button", { disabled: isLoading, type: "submit", className: "btn btn-primary" },
            isLoading && (react_1.default.createElement(react_1.default.Fragment, null,
                react_1.default.createElement("span", { className: "spinner-border spinner-border-sm", role: "status", "aria-hidden": "true" }),
                react_1.default.createElement("span", { className: "sr-only" }, "...Loading"))),
            !isLoading && react_1.default.createElement(react_1.default.Fragment, null, submit.label))));
};
exports.default = FormGenerator;
