"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.generateValidatorFromDef = exports.uiTypeToVType = void 0;
const type_1 = require("../../headless/form/type");
const uiTypeToVType = (t) => {
    switch (t) {
        case type_1.FormType.Number:
        case type_1.FormType.Select:
            return "number";
        case type_1.FormType.Text:
            return "string";
    }
    throw Error("could not map");
};
exports.uiTypeToVType = uiTypeToVType;
const generateValidatorFromDef = (df) => {
    const v = {};
    df.forEach((f) => {
        v[f.name] = {
            optional: f.optional,
            type: exports.uiTypeToVType(f.uiType),
        };
    });
    return v;
};
exports.generateValidatorFromDef = generateValidatorFromDef;
